﻿
{
	int[] data = new int[2] { 1, 2 };

	var t1 = new Thread(() => {
		lock (data) {
			data[0]++;
			data[1]++;
		}
	});
	t1.Start();

	var t2 = new Thread(() => {
		lock (data) {
			data[0]++;
			data[1]++;
		}
	});
	t2.Start();

	t1.Join();
	t2.Join();

	Console.WriteLine(data[0]);
	Console.WriteLine(data[1]);
}
Console.WriteLine(); 
{
	int[] data = new int[2] { 1, 2 };

	var t1 = new Thread(() => {
		lock (data) {
			data = new int[2] { 100, 200 };
			data[0]++;
			data[1]++;
		}
	});
	t1.Start();

	var t2 = new Thread(() => {
		lock (data) {
			data[0]++;
			data[1]++;
		}
	});
	t2.Start();

	t1.Join();
	t2.Join();

	Console.WriteLine(data[0]);
	Console.WriteLine(data[1]);
}
Console.WriteLine(); 
{
	object dataLock = new object();
	int[] data = new int[2] { 1, 2 };

	var t1 = new Thread(() => {
		lock (dataLock) {
			data = new int[2] { 100, 200 };
			data[0]++;
			data[1]++;
		}
	});
	t1.Start();

	var t2 = new Thread(() => {
		lock (dataLock) {
			data[0]++;
			data[1]++;
		}
	});
	t2.Start();

	t1.Join();
	t2.Join();

	Console.WriteLine(data[0]);
	Console.WriteLine(data[1]);
}